package server

import (
	"net/http"

	"github.com/gofiber/fiber/v2"

	def "git.pbiernat.dev/egommerce/order-service/internal/app/definition"
	"git.pbiernat.dev/egommerce/order-service/internal/app/service"
)

func (s *Server) UpdateOrderStatusHandler(c *fiber.Ctx) error {
	reqID, _ := s.GetRequestID(c)
	data := new(def.UpdateOrderStatusRequest)
	if err := c.BodyParser(data); err != nil {
		return err
	}

	// check if order exists in DB service...
	orderId := c.Params("orderId")
	var err error
	if orderId == "" || err != nil {
		return c.SendStatus(http.StatusBadRequest)
	}

	order := service.NewOrderService(s.ebCh, s.log)
	order.UpdateOrderStatus(reqID, orderId, data.Status)

	return c.SendStatus(http.StatusNoContent)
}
